#encoding: utf-8
# ------------------------------
# Mod pour \pokemonsdk\scripts\01500 Alpha 24 Battle Engine (deprecated)\01600 Scene_Battle\01500 Scene_Battle_BEGEND_Turn.rb
# ------------------------------
# Modifie la phrase de dégâts des PdR selon vulnérabilité (CSV 100100 de Sacred Phoenix requis)

class Scene_Battle
	def switch_turn_entry_hasard(pokemon)
		return unless pokemon and !pokemon.dead?
		#>> Vérifier garde magique pour picot, piege de rock et pics toxiques !
		_state = ::BattleEngine.state
		_is_enemy = pokemon.position < 0
		#>Picot
		if((value = _state[_is_enemy ? :enn_spikes : :act_spikes]) > 0 and ::BattleEngine._is_grounded(pokemon))
			hp = pokemon.max_hp * (2 + value - 1) / 16
			if(hp > 0)
				BattleEngine::_message_stack_push([:hp_down, pokemon, hp, true])
				BattleEngine::_msgp(19, 854, pokemon)
				phase4_message_display
			end
		end
		#>Piege de rock
		if(_state[_is_enemy ? :enn_stealth_rock : :act_stealth_rock])
			hp = pokemon.battle_effect.get_stealth_rock_dammages(pokemon)
			# Recalcul du mod (Avoir changé de class a déinitialisé la valeur)
			mod = GameData::Type[pokemon.type1].hit_by(13) *
				GameData::Type[pokemon.type2].hit_by(13) *
				GameData::Type[pokemon.type3].hit_by(13)
			if pokemon.type_rock? #Immunité type Roche
				sr_efficiency = 0
			elsif mod > 2
				sr_efficiency = 4
			elsif mod > 1
				sr_efficiency = 2
			elsif mod > 0.5
				sr_efficiency = 1
			elsif mod > 0.25
				sr_efficiency = 0.5
			else
				sr_efficiency = 0.25
			end			
			
			if(hp > 0)
				BattleEngine::_message_stack_push([:hp_down, pokemon, hp, true])
				if sr_efficiency == 4
					BattleEngine::_msgp(100, 35, pokemon)
					Audio.se_play("Audio/SE/Hit extremely effective.wav")
				elsif sr_efficiency == 2
					BattleEngine::_msgp(100, 38, pokemon)
					Audio.se_play("Audio/SE/hitplus.wav")
				elsif sr_efficiency == 1
					BattleEngine::_msgp(100, 41, pokemon)
					Audio.se_play("Audio/SE/hit.wav")
				elsif sr_efficiency == 0.5
					BattleEngine::_msgp(100, 44, pokemon)
					Audio.se_play("Audio/SE/hitlow.wav")
				elsif sr_efficiency == 0.25
					BattleEngine::_msgp(100, 47, pokemon)
					Audio.se_play("Audio/SE/Hit not at all effective.wav")
				else
					BattleEngine::_msgp(100, 50, pokemon)
				end
				phase4_message_display
			end
		end
		#>Pics Toxic # Vérifier s'il n'y a pas conflit avec le mod Stacking Poison.
		if((value = _state[_is_enemy ? :enn_toxic_spikes : :act_toxic_spikes]) > 0 and ::BattleEngine._is_grounded(pokemon))
			if(pokemon.type_poison?)
				_state[_is_enemy ? :enn_toxic_spikes : :act_toxic_spikes] = 0
				BattleEngine::_msgp(18, _is_enemy ? 161 : 160)
			elsif(pokemon.can_be_poisoned?)
				#BattleEngine::_msgp(19, 854, pokemon)
				BattleEngine::_message_stack_push([value == 1 ? :status_poison : :status_toxic, pokemon])
			end
			phase4_message_display
		end
		#>Toile gluante
		if((value = _state[_is_enemy ? :enn_sticky_web : :act_sticky_web]) and ::BattleEngine._is_grounded(pokemon))
			BattleEngine::_message_stack_push([:apply_effect, pokemon, :sticky_web])
			BattleEngine::_msgp(19, 1222, pokemon)
			phase4_message_display
		end
		if BattleEngine._has_item(pokemon, 541) #> Ballon
			BattleEngine._msgp(19, 408, pokemon)
		end
	end
end